<?php

// ----------> konstanty

define( 'CURRENT_DATE', date_i18n('Y-m-d') );
define( 'CURRENT_DATE_TIME', date_i18n('Y-m-d H:i') );
define( 'CURRENT_YEAR', date_i18n('Y') );
define( 'POSTS_PER_PAGE', get_option('posts_per_page') );
define( 'TEMP_NAME', get_bloginfo( 'name' ) );
define( 'TEMP_DESC', get_bloginfo( 'description' ) );
define( 'TEMP_URI', get_template_directory_uri() );
define( 'TEXTDOMAIN', 'ctu_cz' );



// ----------> WEB - překlady

	load_theme_textdomain( TEXTDOMAIN, TEMP_URI . '/languages' );



// ----------> assets

add_action( 'wp_enqueue_scripts', function() {
	//wp_register_style( 'google-webfont', 'https://fonts.googleapis.com/css2?family=Roboto+Slab:wght@400;700&family=Roboto:ital,wght@0,300;0,400;0,500;0,700;1,400&display=swap', false );

	wp_register_style( 'normalize', TEMP_URI . '/assets/vendors/css/normalize.css', array(), null, 'all' );
	wp_register_style( 'lightcase', TEMP_URI . '/assets/vendors/css/lightcase.css', array(), null, 'all' );
	wp_register_style( 'project-css', TEMP_URI . CSS_PATH . '/assets/css/style.css', array(), filemtime(substr( parse_url( TEMP_URI . CSS_PATH . '/assets/css/style.css', PHP_URL_PATH ), 1 )), 'all' );
	wp_register_script( 'events-touch', TEMP_URI . '/assets/vendors/js/jquery.events.touch.js', array('jquery'), '1.5.0', true );
	wp_register_script( 'lightcase', TEMP_URI . '/assets/vendors/js/lightcase.js', array('jquery'), '2.5.0', true );
	wp_register_script( 'fitvids', TEMP_URI . '/assets/vendors/js/jquery.fitvids.js', array('jquery'), '1.1', true );
	wp_register_script( 'project-js', TEMP_URI . '/assets/js/main.js', array('jquery'), filemtime(substr( parse_url( TEMP_URI.'/assets/js/main.js', PHP_URL_PATH ), 1 )), true );

	//wp_enqueue_style( 'google-webfont' );
	wp_enqueue_style( 'normalize' );

	if (is_single() || is_page()) {
		wp_enqueue_style( 'lightcase' );
		wp_enqueue_script( 'events-touch' );
		wp_enqueue_script( 'lightcase' );
		wp_enqueue_script( 'fitvids' );
	}

	wp_enqueue_style( 'project-css' );
	wp_enqueue_script( 'project-js' );
});



// ----------> ADMIN - úpravy

add_action( 'pre_get_posts', function($query) {

	if ( !is_admin() && $query->is_main_query() ) {

		// native search
		if ($query->is_search()) {
			$query->set('post_type', array('_clanky', '_galerie', 'page'));
		}

		// galerie
		if ($query->is_post_type_archive("_galerie")) {
			$query->set('posts_per_page', 16);
		}

		return $query;

	}

}, 1000 );

add_action( 'login_head', function(){ echo '<style type="text/css"> body.login h1 { background: none; margin: 0 0 20px; padding: 0 } body.login h1 a { margin: 0 auto; background: transparent url('.TEMP_URI.'/assets/img/ctu-logo.svg) no-repeat 50% 0 !important; background-size: contain !important; position: relative; left: 0; top: 0; display: block; width: 100px !important; height: 100px !important } </style>'; } );
add_filter( 'login_headerurl', function(){ return home_url('/'); } );
add_filter( 'login_headertitle', function(){ return TEMP_NAME; } );

add_theme_support( 'post-thumbnails', array( '_clanky', '_galerie' ) );
add_image_size( 'full-hd', 1920, 1080 );
add_image_size( 'logo', 200, 70 );

add_shortcode( 'gallery', function( $atts ){ $atts['link'] = 'file'; return gallery_shortcode( $atts ); } );

function wpc_dashboard_widget_function() { echo "⇨ administrace webových stránek"; }
add_action( 'wp_dashboard_setup', function(){
	wp_add_dashboard_widget( 'wp_dashboard_widget', TEMP_NAME, 'wpc_dashboard_widget_function' );
});

add_action( 'wp_dashboard_setup', function(){
	global $wp_meta_boxes;
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_activity']); // Aktivity
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_right_now']); // Aktuální přehled/Right Now
	//unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_recent_comments']); // Recent Comments
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_incoming_links']); // Incoming Links
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_plugins']); // Plugins - Popular, New and Recently updated WordPress Plugins
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_quick_press']); // Quick Press Form
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_recent_drafts']); // Recent Drafts List
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_primary']); // Wordpress Development Blog Feed
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_secondary']); // Other WordPress News Feed
	//unset($wp_meta_boxes['dashboard']['normal']['high']['dashboard_browser_nag']); // hláška o nepodporovaném prohlížeči
	//unset($wp_meta_boxes['dashboard']['normal']['core']['wpseo-dashboard-overview']);
});

remove_action( 'welcome_panel', 'wp_welcome_panel' );

add_action( 'wp_before_admin_bar_render', function(){
	global $wp_admin_bar;
	$wp_admin_bar->remove_menu( 'wp-logo' );
	//$wp_admin_bar->remove_menu( 'comments' );
	$wp_admin_bar->remove_menu( 'updates' );
	$wp_admin_bar->remove_menu( 'new-content' );
});

add_action( 'admin_menu', function(){
	remove_menu_page( 'edit.php' ); // Příspěvky
	//remove_menu_page( 'edit-comments.php' );
	//remove_submenu_page( 'options-general.php', 'options-discussion.php' );
	//remove_submenu_page( 'edit.php', 'post-new.php' );
    //remove_submenu_page( 'edit.php', 'edit-tags.php?taxonomy=category' );
    //remove_submenu_page( 'edit.php', 'edit-tags.php?taxonomy=post_tag' );
});

add_filter( 'custom_menu_order', 'custom_menu_order' );
add_filter( 'menu_order', 'custom_menu_order' );
function custom_menu_order($menu_ord){

    if (!$menu_ord) return true;

    return array(
			'index.php', // Dashboard
			'separator1', // First separator
			'edit.php?post_type=page', // Pages
			'edit.php?post_type=_clanky',
			'edit.php?post_type=_galerie',
			//'edit.php', // Posts
			'edit-comments.php', // Comments
			'separator2', // Second separator
			'separator-last', // Last separator
			'upload.php', // Media
			'users.php', // Users
			'link-manager.php', // Links
			'themes.php', // Appearance
			'plugins.php', // Plugins
			'tools.php', // Tools
			'options-general.php', // Settings
    );

}

add_filter( 'manage_pages_columns', function($posts_columns){
	$posts_columns = array(
		"cb" => '<input type="checkbox" />',
		"title" => __( 'Název' , TEXTDOMAIN ),
	);
	return $posts_columns;
});

add_action( 'admin_menu' , function(){
	remove_meta_box( 'tagsdiv-post_tag' , 'page' , 'side' );
});

//add_filter( 'manage_{$post_type}_posts_columns', 'custom_post_columns', 10, 2 );
add_filter( 'manage_posts_columns', function( $columns, $post_type ){

	switch( $post_type ){

		case '_clanky':
			$columns['post_thumb'] = __( 'Obrázek', TEXTDOMAIN );
			//unset( $columns['date'] );
			unset( $columns['tags'] );
		break;

		case '_galerie':
			$columns['post_thumb'] = __( 'Obrázek', TEXTDOMAIN );
			//unset( $columns['date'] );
			unset( $columns['tags'] );
		break;

	}

	return $columns;

}, 10, 2 );

add_action( 'manage_posts_custom_column', function( $column, $post_id ){

	switch( $column ){

		case 'post_thumb':
			if ( has_post_thumbnail() ) { set_post_thumbnail_size(160,80,true); the_post_thumbnail(); }
		break;

	}

}, 10, 2 );


add_action( 'init', function(){

	register_nav_menus(
		array(
			'navigace' => __( 'Navigace', TEXTDOMAIN ),
			'odkazy-hlavicka' => __( 'Odkazy (horní lišta)', TEXTDOMAIN ),
			'odkazy-paticka' => __( 'Odkazy (patička)', TEXTDOMAIN )
		)
	);

});



// ----------> Umožní zobrazení pouze submenu v hlavní navigaci

add_filter( 'wp_nav_menu_objects', function($items, $args) {

	if ( empty( $args->submenu ) ) {
		return $items;
	}

	$ids = wp_filter_object_list( $items, array( 'title' => $args->submenu ), 'and', 'ID' );
	$parent_id = array_pop( $ids );
	$children  = submenu_get_children_ids( $parent_id, $items );

	foreach ( $items as $key => $item ) {
			if ( ! in_array( $item->ID, $children ) ) {
					unset( $items[$key] );
			}
	}

	return $items;

}, 10, 2 );

function submenu_get_children_ids( $id, $items ) {

  $ids = wp_filter_object_list( $items, array( 'menu_item_parent' => $id ), 'and', 'ID' );

  foreach ( $ids as $id ) {
      $ids = array_merge( $ids, submenu_get_children_ids( $id, $items ) );
  }

  return $ids;

}



// ----------> Odstraní P tagy kolem obrázků

add_filter( 'the_content', function( $content ){ return preg_replace('/<p>(\s*)(<img .* \/>)(\s*)<\/p>/iU', '\2', $content); } );



// ----------> Odstraní inline CSS pro nativní galerie a Emoji

add_filter( 'use_default_gallery_style', '__return_false' );
remove_action( 'wp_print_styles', 'print_emoji_styles' );
remove_action( 'admin_print_styles', 'print_emoji_styles' );
remove_action( 'wp_head', 'print_emoji_detection_script', 7);



// ----------> získá ID postu (i na statické front_page) !!!

function my_ID(){
	return is_front_page() ? get_option('page_on_front') : get_the_ID();
}



// ----------> TITLE

add_filter( 'wp_title', function( $title ){

	if( is_404() ) return '404';
	if( is_home() || is_front_page() ) return ($meta_title = get_post_meta( my_ID(), 'mb_meta_title', true )) ? $meta_title.' - '.TEMP_DESC : TEMP_NAME.' - '.TEMP_DESC;
	return ($meta_title = get_post_meta( my_ID(), 'mb_meta_title', true )) ? $meta_title.' | '.TEMP_NAME : trim($title).' | '.TEMP_NAME;

}, 10, 1 );



// ----------> DESCRIPTION

function meta_description() {
	if (is_single()) {
		$description = get_post_meta( my_ID(), 'mb_meta_description', true ) ? : wp_strip_all_tags( mb_strimwidth(get_the_excerpt(), 0, 160, "..." ), true );
	} else {
		$description = get_post_meta( my_ID(), 'mb_meta_description', true ) ? : TEMP_DESC;
	}
	return $description;
}



// ----------> add class to nav menu for CPT single page

add_filter( 'nav_menu_css_class', function( $classes = array(), $menu_item = false ){

	global $post;
	if( is_post_type_archive() || is_tax() ){
		$classes[] = ($menu_item->url == get_post_type_archive_link($post->post_type)) ? 'current-menu-item active' : '';
	}
	return $classes;

}, 10, 2 );



// ----------> add class to previous/next

add_filter( 'next_posts_link_attributes', 'posts_link_attributes' );
add_filter( 'previous_posts_link_attributes', 'posts_link_attributes' );
function posts_link_attributes() {
    return 'class="btn"';
}



// ----------> disable content editor for custom page

add_action( 'admin_head', function(){

	$template_file = basename( get_page_template() );
	if(
		($template_file == 'homepage.php')
	){
		remove_post_type_support( 'page', 'editor' );
	}

});



// ----------> ponechání hierarchie zaškrtnutých kategorií/taxonomií

add_filter( 'wp_terms_checklist_args', function( $args ){
	$args['checked_ontop'] = false;
	return $args;
});



// ----------> remove IDs a CLASSes from wp_nav_menu

add_filter( 'nav_menu_item_id', '__return_null', 10, 3 );
//add_filter( 'nav_menu_css_class', '__return_empty_array', 10, 3 );



// ----------> enable SVG support to media library

add_filter( 'image_downsize', 'wpse240579_fix_svg_size_attributes', 10, 2 );
function wpse240579_fix_svg_size_attributes( $out, $id ) {
	$image_url  = wp_get_attachment_url( $id );
	$file_ext   = pathinfo( $image_url, PATHINFO_EXTENSION );
	if ( is_admin() || 'svg' !== $file_ext ) {
		return false;
	}
	return array( $image_url, null, null, false );
}
/*
add_filter( 'upload_mimes', 'cc_mime_types' );
function cc_mime_types( $mimes ){
	$mimes['svg'] = 'image/svg+xml';
	return $mimes;
}
*/



// ----------> Post Type Archive Title

function cpt_archive_title($cpt) {
	$obj = get_post_type_object($cpt);
	return apply_filters( 'post_type_archive_title', $obj->labels->menu_name );
}



// ----------> Get Page URL from "page" template

function get_page_link_from_template($template) {
	$page = get_posts(array( 'post_type'=>'page', 'meta_key'=>'_wp_page_template', 'meta_value'=>$template ));
	return current($page)->ID;
}



// ----------> Get WP native gallery image counts from post ID

function get_gallery_count( $id ) {

	$ids = current(wp_list_pluck( get_post_galleries( $id, false ), 'ids' ));
	$ids_arr = explode(',',$ids);
	return count($ids_arr);
	
}



// ----------> Sanitize File Name

add_filter( 'sanitize_file_name', function($filename) {
	$info = pathinfo($filename);
	$ext  = empty($info['extension']) ? '' : '.' . $info['extension'];
	$name = basename($filename, $ext);
	return sanitize_title($name) . $ext;
}, 10 );



// ----------> Comments (fields)

add_filter( 'comment_form_default_fields', function($fields) {
	unset($fields['url']);
	unset($fields['cookies']);
	return $fields;
});



// ----------> custom WP native gallery

add_filter( 'post_gallery', function( $string, $attr ) {

	global $post;
	$i = 0;
	$more = null;
	$gallery_ids = explode( ',', $attr['ids'] );
	$limit = 25;

	$gallery_code = '<div class="wp-gallery gallery">';

	foreach( $gallery_ids as $id ){

		$i++;
		$image_src = wp_get_attachment_image( $id, "thumbnail" );
		$image_detail_src = current( wp_get_attachment_image_src( $id, "full-hd" ) );
		$hidden = $more = null;

		if ( ($i === $limit) && (($count = count($gallery_ids)) > $limit) ) {

			$count = $count - $limit;

			switch ($count) {
				case 1: case 2: case 3: case 4:
					$more_text = 'Další '.$count.' fotografie'; break;
				default:
					$more_text = 'Dalších '.$count.' fotografií'; break;
			}

			$more = '<figcaption>'.$more_text.'</figcaption>';

		}

		if ($i > 8) $hidden = " hidden";

		$gallery_code .= '<figure class="gallery-item'.$hidden.'"><a href="'.$image_detail_src.'" title="'.$post->post_name.'">'.$image_src.$more.'</a></figure>';

	}

	$gallery_code .= '</div>';

	return $gallery_code;


}, 10, 2);



// ----------> disable content editor & features for custom page

add_action( 'admin_head', function() {
	$template_file = basename( get_page_template() );
	if (
		$template_file === "???.php"
	) {
		remove_post_type_support( 'page', 'editor' );
	}
});



// ----------> custom Body Class

add_filter( 'body_class', function( $classes ) {
    if ( is_page_template( 'templates/homepage.php' ) && rwmb_meta( 'mb_rozcestnik_group' ) ) {
        $classes[] = 'homepage-pages';
    }
	return $classes;
} );


// ----------> breadcrumbs NavXT

add_filter( "bcn_post_terms", function($terms, $taxonomy, $id) {

	return null;

}, 10, 3);
